//
// C++ Interface: AnimationSet
//
// Description: 
//
//
// Author: Erik Hjortsberg <erik@katastrof.nu>, (C) 2005
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.//
//
#ifndef EMBEROGREANIMATIONSET_H
#define EMBEROGREANIMATIONSET_H
#include "components/ogre/EmberOgrePrerequisites.h"

namespace EmberOgre {
namespace Model {

struct AnimationPart
{
	Ogre::AnimationState* state;
	Ogre::Real weight;
};


typedef std::vector<AnimationPart> AnimationPartSet;

/**
@author Erik Hjortsberg
*/
class AnimationSet
{
public:
	AnimationSet();
	void addTime(Ogre::Real timeSlice);
	void addAnimationPart(AnimationPart part);
	void setEnabled(bool state);
	/**
	 *    returns true if all animation parts have been played 
	 * @return 
	 */
	bool hasCompleted() const;
	
	inline void setSpeed(Ogre::Real speed) { mSpeed = speed;}
	inline Ogre::Real getSpeed() const { return mSpeed; }
	
protected:
	AnimationPartSet mAnimations;
	Ogre::Real mSpeed;

};

}
}

#endif
